package com.maintain.business.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.maintain.business.domain.ErpClient;
import com.maintain.business.domain.vo.ErpClientVo;
import com.maintain.business.mapper.ErpClientMapper;
import com.maintain.common.excel.ExcelListener;
import com.maintain.common.excel.ExcelResult;
import com.maintain.common.exception.ServiceException;
import com.maintain.common.helper.LoginHelper;
import com.maintain.common.utils.ValidatorUtils;
import com.maintain.common.utils.spring.SpringUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 客户自定义导入
 *
 * @author liushuai
 */
@Slf4j
public class ErpClientImportListener extends AnalysisEventListener<ErpClientVo> implements ExcelListener<ErpClientVo> {

    private final ErpClientMapper clientMapper;

    private final Boolean isUpdateSupport;

    private final String operName;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ErpClientImportListener(Boolean isUpdateSupport) {
        this.clientMapper = SpringUtils.getBean(ErpClientMapper.class);
        this.isUpdateSupport = isUpdateSupport;
        this.operName = LoginHelper.getUsername();
    }

    @Override
    public void invoke(ErpClientVo clientImportVo, AnalysisContext context) {
        LambdaQueryWrapper<ErpClient> erpClientLambdaQueryWrapper = new LambdaQueryWrapper<>();
        erpClientLambdaQueryWrapper.eq(ErpClient::getName, clientImportVo.getName());
        ErpClient erpClient = this.clientMapper.selectOne(erpClientLambdaQueryWrapper);
        try {
            // 验证是否存在这个客户
            if (ObjectUtil.isNull(erpClient)) {
                erpClient = BeanUtil.toBean(clientImportVo, ErpClient.class);
                ValidatorUtils.validate(erpClient);
                clientMapper.insert(erpClient);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、客户 ").append(erpClient.getName()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long clientId = erpClient.getId();
                erpClient = BeanUtil.toBean(clientImportVo, ErpClient.class);
                erpClient.setId(clientId);
                ValidatorUtils.validate(erpClient);
                clientMapper.updateById(erpClient);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、客户 ").append(erpClient.getName()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、客户 ").append(erpClient.getName()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、客户 " + erpClient.getName() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<ErpClientVo> getExcelResult() {
        return new ExcelResult<ErpClientVo>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<ErpClientVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
